'
' Application of API function GetOpenFileNameW function (Comdlg32.dll)
' version 2 -- multiple file selection
'
' https://learn.microsoft.com/en-us/windows/win32/api/commdlg/nf-commdlg-getopenfilenamew
' https://learn.microsoft.com/en-us/windows/win32/api/commdlg/ns-commdlg-openfilenamew
'
' requires COM server module DynaLib (http://eriedel.info/)
'
Dim arg, cb, dlgtitle, flags, fname, fnamecc, folder, msg, obj, ofnstruct, t, x

Set obj = CreateObject("DynaLib.Caller")
cb = 88
ofnstruct = String(cb / 2, 0)
obj.InsertNumber ofnstruct, cb, 1

fnamecc = 4096
fname = obj.CreateString(fnamecc)
obj.InsertNumber ofnstruct, fname, 29
obj.InsertNumber ofnstruct, fnamecc, 33

dlgtitle = obj.CreateString(0, "Open File Dialog Sample")
obj.InsertNumber ofnstruct, dlgtitle, 49

' OFN_ALLOWMULTISELECT + OFN_PATHMUSTEXIST + OFN_FILEMUSTEXIST + OFN_EXPLORER
flags = &h200 + &h800 + &h1000+ &h80000
obj.InsertNumber ofnstruct, flags, 53

folder = obj.CreateString(0, WScript.CreateObject("WScript.Shell").CurrentDirectory)
obj.InsertNumber ofnstruct, folder, 45

arg = Array(ofnstruct)
x = obj.CallFunc("Comdlg32.dll", "GetOpenFileNameW", arg)

If x Then
    msg = obj.GetString(fname)
    t = InStr(msg, vbNullChar & vbNullChar)
    msg = Left(msg, t)
    msg = Replace(msg, vbNullChar, vbNewLine)
Else
    msg = "Cancellation or failure"
End If
Set obj = Nothing
MsgBox msg

Wscript.Quit

